/*
 *  Flash Rom Disk Driver
 *
 *  Copyright (C) 2001-2004  BUFFALO INC.
 *
 *  This software may be used and distributed according to the terms of
 *  the GNU General Public License (GPL), incorporated herein by reference.
 *  Drivers based on or derived from this code fall under the GPL and must
 *  retain the authorship, copyright and license notice.  This file is not
 *  a complete program and may only be used when the entire operating
 *  system is licensed under the GPL.
 *
 */
#ifndef _H_FLASHD_HEAD_
#define _H_FLASHD_HEAD_

#include <melco/melco_hwctl.h>

struct flash_dev_func {
	char *flash_name;
	int  blocksizes;
	int (*probe)(void);
	int (*blk_erase)(unsigned long addr ,int num);
	int (*blk_write)(unsigned long addr ,unsigned char* buf,int size);
	int (*blk_read) (unsigned long addr ,unsigned char* buf,int size);
	};

struct flashd_list {
	unsigned long start_addr;
	unsigned long length;
	unsigned char rom_type;
	};

struct flash_info {
	struct flash_dev_func* device;
	unsigned long          start_addr;
	unsigned long          length;
	struct inode           *inode;
	unsigned char          rom_type;
	};

#define ATTACH_FLASH_ADDRESS_1 0xFF000000
#define ATTACH_FLASH_ADDRESS_2 0xFF800000
#define FLASH_WRITE_ENABLE  HWCtl_Rom_Write_Enable()
#define FLASH_WRITE_DISABLE HWCtl_Rom_Write_Disable()

#define PPC_CFG_REG  0xFEC00000
#define PPC_DAT_REG  0xFEE00000

#define PPC_CFG_PCIR 0x800000A8

#define ROM_ON_BORD 0
#define ROM_MINIPCI 1

#define WINBOND_VENDOR_ID 0x10AD
#define WINBOND_DEVICE_ID 0x0565

#define WINBOND_VENDOR_REG   0x00
#define WINBOND_DEVICE_REG   0x02
#define WINBOND_CSC_REG      0x4D

typedef volatile unsigned long*    pvlong;
typedef volatile unsigned short*   pvshort;

#endif
